
<!doctype html>
<html lang="en" class="no-js">
  <head>
    
      <meta charset="utf-8">
      <meta name="viewport" content="width=device-width,initial-scale=1">
      
      
      
      <link rel="icon" href="../../assets/images/favicon.png">
      <meta name="generator" content="mkdocs-1.3.0, mkdocs-material-8.5.4">
    
    
      
        <title>Examples (XMI) - Eclipse Hawk™</title>
      
    
    
      <link rel="stylesheet" href="../../assets/stylesheets/main.80dcb947.min.css">
      
        
        <link rel="stylesheet" href="../../assets/stylesheets/palette.cbb835fc.min.css">
        
          
          
          <meta name="theme-color" content="#7e56c2">
        
      
      

    
    
    
      
        
        
        <link rel="preconnect" href="https://fonts.gstatic.com" crossorigin>
        <link rel="stylesheet" href="https://fonts.googleapis.com/css?family=Roboto:300,300i,400,400i,700,700i%7CRoboto+Mono:400,400i,700,700i&display=fallback">
        <style>:root{--md-text-font:"Roboto";--md-code-font:"Roboto Mono"}</style>
      
    
    
      <link rel="stylesheet" href="../../stylesheets/extra.css">
    
    <script>__md_scope=new URL("../..",location),__md_hash=e=>[...e].reduce((e,_)=>(e<<5)-e+_.charCodeAt(0),0),__md_get=(e,_=localStorage,t=__md_scope)=>JSON.parse(_.getItem(t.pathname+"."+e)),__md_set=(e,_,t=localStorage,a=__md_scope)=>{try{t.setItem(a.pathname+"."+e,JSON.stringify(_))}catch(e){}}</script>
    
      

    
    
    
<!-- FAVICON -->
<link rel="apple-touch-icon" sizes="180x180" href="../../assets/images/apple-touch-icon.png">
<link rel="icon" type="image/png" sizes="32x32" href="../../assets/images/favicon-32x32.png">
<link rel="icon" type="image/png" sizes="16x16" href="../../assets/images/favicon-16x16.png">
<link rel="mask-icon" href="../../assets/images/safari-pinned-tab.svg" color="#5bbad5">
<link rel="shortcut icon" href="../../assets/images/favicon.ico">
<meta name="msapplication-TileColor" content="#b91d47">
<meta name="msapplication-config" content="../../assets/images/browserconfig.xml">
<meta name="theme-color" content="#ffffff">

  </head>
  
  
    
    
    
    
    
    <body dir="ltr" data-md-color-scheme="" data-md-color-primary="deep-purple" data-md-color-accent="deep-purple">
  
    
    
    <input class="md-toggle" data-md-toggle="drawer" type="checkbox" id="__drawer" autocomplete="off">
    <input class="md-toggle" data-md-toggle="search" type="checkbox" id="__search" autocomplete="off">
    <label class="md-overlay" for="__drawer"></label>
    <div data-md-component="skip">
      
        
        <a href="#example-queries-on-xmi-models" class="md-skip">
          Skip to content
        </a>
      
    </div>
    <div data-md-component="announce">
      
    </div>
    
    
      

<header class="md-header" data-md-component="header">
  <nav class="md-header__inner md-grid" aria-label="Header">
    <a href="../.." title="Eclipse Hawk™" class="md-header__button md-logo" aria-label="Eclipse Hawk™" data-md-component="logo">
      
  <img src="../../assets/images/hawk-logo-white.svg" alt="logo">

    </a>
    <label class="md-header__button md-icon" for="__drawer">
      <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24"><path d="M3 6h18v2H3V6m0 5h18v2H3v-2m0 5h18v2H3v-2Z"/></svg>
    </label>
    <div class="md-header__title" data-md-component="header-title">
      <div class="md-header__ellipsis">
        <div class="md-header__topic">
          <span class="md-ellipsis">
            Eclipse Hawk™
          </span>
        </div>
        <div class="md-header__topic" data-md-component="header-topic">
          <span class="md-ellipsis">
            
              Examples (XMI)
            
          </span>
        </div>
      </div>
    </div>
    
    
    
      <label class="md-header__button md-icon" for="__search">
        <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24"><path d="M9.5 3A6.5 6.5 0 0 1 16 9.5c0 1.61-.59 3.09-1.56 4.23l.27.27h.79l5 5-1.5 1.5-5-5v-.79l-.27-.27A6.516 6.516 0 0 1 9.5 16 6.5 6.5 0 0 1 3 9.5 6.5 6.5 0 0 1 9.5 3m0 2C7 5 5 7 5 9.5S7 14 9.5 14 14 12 14 9.5 12 5 9.5 5Z"/></svg>
      </label>
      <div class="md-search" data-md-component="search" role="dialog">
  <label class="md-search__overlay" for="__search"></label>
  <div class="md-search__inner" role="search">
    <form class="md-search__form" name="search">
      <input type="text" class="md-search__input" name="query" aria-label="Search" placeholder="Search" autocapitalize="off" autocorrect="off" autocomplete="off" spellcheck="false" data-md-component="search-query" required>
      <label class="md-search__icon md-icon" for="__search">
        <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24"><path d="M9.5 3A6.5 6.5 0 0 1 16 9.5c0 1.61-.59 3.09-1.56 4.23l.27.27h.79l5 5-1.5 1.5-5-5v-.79l-.27-.27A6.516 6.516 0 0 1 9.5 16 6.5 6.5 0 0 1 3 9.5 6.5 6.5 0 0 1 9.5 3m0 2C7 5 5 7 5 9.5S7 14 9.5 14 14 12 14 9.5 12 5 9.5 5Z"/></svg>
        <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24"><path d="M20 11v2H8l5.5 5.5-1.42 1.42L4.16 12l7.92-7.92L13.5 5.5 8 11h12Z"/></svg>
      </label>
      <nav class="md-search__options" aria-label="Search">
        
        <button type="reset" class="md-search__icon md-icon" title="Clear" aria-label="Clear" tabindex="-1">
          <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24"><path d="M19 6.41 17.59 5 12 10.59 6.41 5 5 6.41 10.59 12 5 17.59 6.41 19 12 13.41 17.59 19 19 17.59 13.41 12 19 6.41Z"/></svg>
        </button>
      </nav>
      
    </form>
    <div class="md-search__output">
      <div class="md-search__scrollwrap" data-md-scrollfix>
        <div class="md-search-result" data-md-component="search-result">
          <div class="md-search-result__meta">
            Initializing search
          </div>
          <ol class="md-search-result__list"></ol>
        </div>
      </div>
    </div>
  </div>
</div>
    
    
      <div class="md-header__source">
        <a href="https://gitlab.eclipse.org/eclipse/hawk/hawk/" title="Go to repository" class="md-source" data-md-component="source">
  <div class="md-source__icon md-icon">
    
    <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 448 512"><!--! Font Awesome Free 6.2.0 by @fontawesome - https://fontawesome.com License - https://fontawesome.com/license/free (Icons: CC BY 4.0, Fonts: SIL OFL 1.1, Code: MIT License) Copyright 2022 Fonticons, Inc.--><path d="M439.55 236.05 244 40.45a28.87 28.87 0 0 0-40.81 0l-40.66 40.63 51.52 51.52c27.06-9.14 52.68 16.77 43.39 43.68l49.66 49.66c34.23-11.8 61.18 31 35.47 56.69-26.49 26.49-70.21-2.87-56-37.34L240.22 199v121.85c25.3 12.54 22.26 41.85 9.08 55a34.34 34.34 0 0 1-48.55 0c-17.57-17.6-11.07-46.91 11.25-56v-123c-20.8-8.51-24.6-30.74-18.64-45L142.57 101 8.45 235.14a28.86 28.86 0 0 0 0 40.81l195.61 195.6a28.86 28.86 0 0 0 40.8 0l194.69-194.69a28.86 28.86 0 0 0 0-40.81z"/></svg>
  </div>
  <div class="md-source__repository">
    Git repository @ Eclipse
  </div>
</a>
      </div>
    
  </nav>
  
</header>
    
    <div class="md-container" data-md-component="container">
      
      
        
          
        
      
      <main class="md-main" data-md-component="main">
        <div class="md-main__inner md-grid">
          
            
              
              <div class="md-sidebar md-sidebar--primary" data-md-component="sidebar" data-md-type="navigation" >
                <div class="md-sidebar__scrollwrap">
                  <div class="md-sidebar__inner">
                    


<nav class="md-nav md-nav--primary" aria-label="Navigation" data-md-level="0">
  <label class="md-nav__title" for="__drawer">
    <a href="../.." title="Eclipse Hawk™" class="md-nav__button md-logo" aria-label="Eclipse Hawk™" data-md-component="logo">
      
  <img src="../../assets/images/hawk-logo-white.svg" alt="logo">

    </a>
    Eclipse Hawk™
  </label>
  
    <div class="md-nav__source">
      <a href="https://gitlab.eclipse.org/eclipse/hawk/hawk/" title="Go to repository" class="md-source" data-md-component="source">
  <div class="md-source__icon md-icon">
    
    <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 448 512"><!--! Font Awesome Free 6.2.0 by @fontawesome - https://fontawesome.com License - https://fontawesome.com/license/free (Icons: CC BY 4.0, Fonts: SIL OFL 1.1, Code: MIT License) Copyright 2022 Fonticons, Inc.--><path d="M439.55 236.05 244 40.45a28.87 28.87 0 0 0-40.81 0l-40.66 40.63 51.52 51.52c27.06-9.14 52.68 16.77 43.39 43.68l49.66 49.66c34.23-11.8 61.18 31 35.47 56.69-26.49 26.49-70.21-2.87-56-37.34L240.22 199v121.85c25.3 12.54 22.26 41.85 9.08 55a34.34 34.34 0 0 1-48.55 0c-17.57-17.6-11.07-46.91 11.25-56v-123c-20.8-8.51-24.6-30.74-18.64-45L142.57 101 8.45 235.14a28.86 28.86 0 0 0 0 40.81l195.61 195.6a28.86 28.86 0 0 0 40.8 0l194.69-194.69a28.86 28.86 0 0 0 0-40.81z"/></svg>
  </div>
  <div class="md-source__repository">
    Git repository @ Eclipse
  </div>
</a>
    </div>
  
  <ul class="md-nav__list" data-md-scrollfix>
    
      
      
      

  
  
  
    <li class="md-nav__item">
      <a href="../.." class="md-nav__link">
        Home
      </a>
    </li>
  

    
      
      
      

  
  
    
  
  
    
    <li class="md-nav__item md-nav__item--active md-nav__item--nested">
      
      
        <input class="md-nav__toggle md-toggle" data-md-toggle="__nav_2" type="checkbox" id="__nav_2" checked>
      
      
      
      
        <label class="md-nav__link" for="__nav_2">
          Basic use
          <span class="md-nav__icon md-icon"></span>
        </label>
      
      <nav class="md-nav" aria-label="Basic use" data-md-level="1">
        <label class="md-nav__title" for="__nav_2">
          <span class="md-nav__icon md-icon"></span>
          Basic use
        </label>
        <ul class="md-nav__list" data-md-scrollfix>
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../installation/" class="md-nav__link">
        Installation
      </a>
    </li>
  

            
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../core-concepts/" class="md-nav__link">
        Core concepts
      </a>
    </li>
  

            
          
            
              
  
  
    
  
  
    <li class="md-nav__item md-nav__item--active">
      
      <input class="md-nav__toggle md-toggle" data-md-toggle="toc" type="checkbox" id="__toc">
      
      
        
      
      
        <label class="md-nav__link md-nav__link--active" for="__toc">
          Examples (XMI)
          <span class="md-nav__icon md-icon"></span>
        </label>
      
      <a href="./" class="md-nav__link md-nav__link--active">
        Examples (XMI)
      </a>
      
        

<nav class="md-nav md-nav--secondary" aria-label="Table of contents">
  
  
  
    
  
  
    <label class="md-nav__title" for="__toc">
      <span class="md-nav__icon md-icon"></span>
      Table of contents
    </label>
    <ul class="md-nav__list" data-md-component="toc" data-md-scrollfix>
      
        <li class="md-nav__item">
  <a href="#all-instances-of-a-type" class="md-nav__link">
    All instances of a type
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#reference-slots-in-a-type" class="md-nav__link">
    Reference slots in a type
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#reference-traversal" class="md-nav__link">
    Reference traversal
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#reverse-reference-traversal" class="md-nav__link">
    Reverse reference traversal
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#range-queries-with-indexed-or-derived-integer-attributes" class="md-nav__link">
    Range queries with indexed or derived integer attributes
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#advanced-example-loops-variables-and-custom-operations" class="md-nav__link">
    Advanced example: loops, variables and custom operations
  </a>
  
</li>
      
    </ul>
  
</nav>
      
    </li>
  

            
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../examples-modelio/" class="md-nav__link">
        Examples (Modelio)
      </a>
    </li>
  

            
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../papyrus/" class="md-nav__link">
        Papyrus UML support
      </a>
    </li>
  

            
          
        </ul>
      </nav>
    </li>
  

    
      
      
      

  
  
  
    
    <li class="md-nav__item md-nav__item--nested">
      
      
        <input class="md-nav__toggle md-toggle" data-md-toggle="__nav_3" type="checkbox" id="__nav_3" >
      
      
      
      
        <label class="md-nav__link" for="__nav_3">
          Advanced use
          <span class="md-nav__icon md-icon"></span>
        </label>
      
      <nav class="md-nav" aria-label="Advanced use" data-md-level="1">
        <label class="md-nav__title" for="__nav_3">
          <span class="md-nav__icon md-icon"></span>
          Advanced use
        </label>
        <ul class="md-nav__list" data-md-scrollfix>
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../../advanced-use/graph-as-emf/" class="md-nav__link">
        Graph as EMF model
      </a>
    </li>
  

            
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../../advanced-use/advanced-props/" class="md-nav__link">
        Advanced properties
      </a>
    </li>
  

            
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../../advanced-use/meta-queries/" class="md-nav__link">
        Meta-level queries
      </a>
    </li>
  

            
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../../advanced-use/temporal-queries/" class="md-nav__link">
        Temporal queries
      </a>
    </li>
  

            
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../../advanced-use/oomph/" class="md-nav__link">
        Oomph and Hawk
      </a>
    </li>
  

            
          
        </ul>
      </nav>
    </li>
  

    
      
      
      

  
  
  
    
    <li class="md-nav__item md-nav__item--nested">
      
      
        <input class="md-nav__toggle md-toggle" data-md-toggle="__nav_4" type="checkbox" id="__nav_4" >
      
      
      
      
        <label class="md-nav__link" for="__nav_4">
          Server
          <span class="md-nav__icon md-icon"></span>
        </label>
      
      <nav class="md-nav" aria-label="Server" data-md-level="1">
        <label class="md-nav__title" for="__nav_4">
          <span class="md-nav__icon md-icon"></span>
          Server
        </label>
        <ul class="md-nav__list" data-md-scrollfix>
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../../server/architecture/" class="md-nav__link">
        Architecture
      </a>
    </li>
  

            
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../../server/api/" class="md-nav__link">
        Thrift API
      </a>
    </li>
  

            
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../../server/api-security/" class="md-nav__link">
        Thrift API security
      </a>
    </li>
  

            
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../../server/deployment/" class="md-nav__link">
        Deployment
      </a>
    </li>
  

            
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../../server/cli/" class="md-nav__link">
        Console client
      </a>
    </li>
  

            
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../../server/eclipse/" class="md-nav__link">
        Eclipse client
      </a>
    </li>
  

            
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../../server/other-languages/" class="md-nav__link">
        Cross-language clients
      </a>
    </li>
  

            
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../../server/file-config/" class="md-nav__link">
        File-based configuration
      </a>
    </li>
  

            
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../../server/logging/" class="md-nav__link">
        Logging
      </a>
    </li>
  

            
          
        </ul>
      </nav>
    </li>
  

    
      
      
      

  
  
  
    
    <li class="md-nav__item md-nav__item--nested">
      
      
        <input class="md-nav__toggle md-toggle" data-md-toggle="__nav_5" type="checkbox" id="__nav_5" >
      
      
      
      
        <label class="md-nav__link" for="__nav_5">
          Developers
          <span class="md-nav__icon md-icon"></span>
        </label>
      
      <nav class="md-nav" aria-label="Developers" data-md-level="1">
        <label class="md-nav__title" for="__nav_5">
          <span class="md-nav__icon md-icon"></span>
          Developers
        </label>
        <ul class="md-nav__list" data-md-scrollfix>
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../../developers/run-from-source/" class="md-nav__link">
        Run GUI from source
      </a>
    </li>
  

            
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../../developers/server-from-source/" class="md-nav__link">
        Run Server from source
      </a>
    </li>
  

            
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../../developers/plain-maven/" class="md-nav__link">
        Build with plain Maven
      </a>
    </li>
  

            
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../../developers/website/" class="md-nav__link">
        Work on the website
      </a>
    </li>
  

            
          
        </ul>
      </nav>
    </li>
  

    
      
      
      

  
  
  
    
    <li class="md-nav__item md-nav__item--nested">
      
      
        <input class="md-nav__toggle md-toggle" data-md-toggle="__nav_6" type="checkbox" id="__nav_6" >
      
      
      
      
        <label class="md-nav__link" for="__nav_6">
          Community
          <span class="md-nav__icon md-icon"></span>
        </label>
      
      <nav class="md-nav" aria-label="Community" data-md-level="1">
        <label class="md-nav__title" for="__nav_6">
          <span class="md-nav__icon md-icon"></span>
          Community
        </label>
        <ul class="md-nav__list" data-md-scrollfix>
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="https://www.eclipse.org/forums/index.php/f/442/" class="md-nav__link">
        Forum
      </a>
    </li>
  

            
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="https://gitlab.eclipse.org/eclipse/hawk/hawk/-/issues/new" class="md-nav__link">
        File a bug
      </a>
    </li>
  

            
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="https://gitlab.eclipse.org/eclipse/hawk/hawk/-/issues" class="md-nav__link">
        Open bugs
      </a>
    </li>
  

            
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="https://ci.eclipse.org/hawk/" class="md-nav__link">
        Builds
      </a>
    </li>
  

            
          
        </ul>
      </nav>
    </li>
  

    
      
      
      

  
  
  
    <li class="md-nav__item">
      <a href="../../additional-resources/" class="md-nav__link">
        Additional resources
      </a>
    </li>
  

    
  </ul>
</nav>
                  </div>
                </div>
              </div>
            
            
              
              <div class="md-sidebar md-sidebar--secondary" data-md-component="sidebar" data-md-type="toc" >
                <div class="md-sidebar__scrollwrap">
                  <div class="md-sidebar__inner">
                    

<nav class="md-nav md-nav--secondary" aria-label="Table of contents">
  
  
  
    
  
  
    <label class="md-nav__title" for="__toc">
      <span class="md-nav__icon md-icon"></span>
      Table of contents
    </label>
    <ul class="md-nav__list" data-md-component="toc" data-md-scrollfix>
      
        <li class="md-nav__item">
  <a href="#all-instances-of-a-type" class="md-nav__link">
    All instances of a type
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#reference-slots-in-a-type" class="md-nav__link">
    Reference slots in a type
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#reference-traversal" class="md-nav__link">
    Reference traversal
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#reverse-reference-traversal" class="md-nav__link">
    Reverse reference traversal
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#range-queries-with-indexed-or-derived-integer-attributes" class="md-nav__link">
    Range queries with indexed or derived integer attributes
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#advanced-example-loops-variables-and-custom-operations" class="md-nav__link">
    Advanced example: loops, variables and custom operations
  </a>
  
</li>
      
    </ul>
  
</nav>
                  </div>
                </div>
              </div>
            
          
          
            <div class="md-content" data-md-component="content">
              <article class="md-content__inner md-typeset">
                
                  


<h1 id="example-queries-on-xmi-models">Example queries on XMI models<a class="headerlink" href="#example-queries-on-xmi-models" title="Permanent link">&para;</a></h1>
<p>These are some sample queries that can be done on any set of indexed XMI-based UML models, assuming that <code>Class::name</code> has been added as an indexed attribute and <code>Class::ownedOperationCount</code> has been defined as a derived attribute (as showed in <a href="../core-concepts/">the core concepts page</a>). All the queries are written in the <a href="http://www.eclipse.org/epsilon/doc/eol/">Epsilon Object Language</a>.</p>
<p>In order to index XMI-based UML models, you only need to enable the <code>UMLMetaModelResourceFactory</code> and <code>UMLModelResourceFactory</code> plugins when you create a new Hawk instance, and ensure your files have the <code>.uml</code> extension. If you are using any predefined UML data types, you may also want to add a <code>PredefinedUMLLibraries</code> location inside "Indexed Locations": that will integrate those predefined objects into the Hawk graph, allowing you to reference them on queries.</p>
<p>The rest of this article will run on <a href="https://raw.githubusercontent.com/mondo-project/mondo-hawk/gh-pages/examples/models/zoo/zoo.xmi">this toy XMI-based UML file</a>, which was exported from <a href="../../assets/Zoo.modelio.zip">this Modelio 3.2.1 project</a>:</p>
<p><img alt="Example UML model" src="../img/zoo-classes.png" /></p>
<p>To avoid ambiguity in type names, the default namespaces list in the query dialog should include the UML metamodel URI (<code>http://www.eclipse.org/uml2/5.0.0/UML</code> for the above <code>UML.ecore</code> file).</p>
<h2 id="all-instances-of-a-type">All instances of a type<a class="headerlink" href="#all-instances-of-a-type" title="Permanent link">&para;</a></h2>
<div class="codehilite"><pre><span></span><code>return Class.all.size;
</code></pre></div>

<p>Returns the total number of classes within the specified scope. If you leave "Context Files" empty, it'll count all the classes in all the projects. If you put "*OSS.modelio.zip" in "Context Files", it'll count only the classes within the OSS project. This is faster than going through the model because we can go to the Class node and then simply count all the incoming edges with label "ofType".</p>
<p>You should obtain this result:</p>
<div class="codehilite"><pre><span></span><code>6
</code></pre></div>

<h2 id="reference-slots-in-a-type">Reference slots in a type<a class="headerlink" href="#reference-slots-in-a-type" title="Permanent link">&para;</a></h2>
<div class="codehilite"><pre><span></span><code>return Model.types.selectOne(t|t.name=&#39;Class&#39;).references;
</code></pre></div>

<p>Gives you all the reference slots in the UML "Class" type. This is an example of the queries that can be performed at the "meta" level: more details are available in [[Meta level queries in Hawk]]. The result would look like this:</p>
<div class="codehilite"><pre><span></span><code>[Slot [typeNode=...], Slot [...], ...]
</code></pre></div>

<h2 id="reference-traversal">Reference traversal<a class="headerlink" href="#reference-traversal" title="Permanent link">&para;</a></h2>
<div class="codehilite"><pre><span></span><code>return Class.all
  .select(c|c.qualifiedName=&#39;zoo::Zebra&#39;)
  .superClass.flatten.name;
</code></pre></div>

<p>Gives you the names of all the superclasses of class <code>Zebra</code> within model <code>zoo</code>:</p>
<div class="codehilite"><pre><span></span><code>[Animal]
</code></pre></div>

<h2 id="reverse-reference-traversal">Reverse reference traversal<a class="headerlink" href="#reverse-reference-traversal" title="Permanent link">&para;</a></h2>
<div class="codehilite"><pre><span></span><code>return Class.all
  .select(c|c.qualifiedName=&#39;zoo::Animal&#39;)
  .revRefNav_superClass.flatten.name;
</code></pre></div>

<p>Gives the names of all the <em>sub</em>classes of <code>Animal</code> (follows "superClass" in reverse). The UML metamodel doesn't have "subclass" links, but we can use Hawk's automatic support for reverse traversal of references. In general, if <code>x.e</code> is a reference, we can follow it in reverse with <code>x.revRefNav_e</code>. We can also access containers using <code>x.eContainer</code>.</p>
<p>Result:</p>
<div class="codehilite"><pre><span></span><code>[Elephant, Zebra, Lion]
</code></pre></div>

<h2 id="range-queries-with-indexed-or-derived-integer-attributes">Range queries with indexed or derived integer attributes<a class="headerlink" href="#range-queries-with-indexed-or-derived-integer-attributes" title="Permanent link">&para;</a></h2>
<div class="codehilite"><pre><span></span><code>return Class.all.select(c|c.ownedOperationCount &gt; 0).name;
</code></pre></div>

<p>Finds the names of the classes with at least one operation of their own.</p>
<p>Result:</p>
<div class="codehilite"><pre><span></span><code>[Lion, Animal, Elephant, Zebra]
</code></pre></div>

<h2 id="advanced-example-loops-variables-and-custom-operations">Advanced example: loops, variables and custom operations<a class="headerlink" href="#advanced-example-loops-variables-and-custom-operations" title="Permanent link">&para;</a></h2>
<div class="codehilite"><pre><span></span><code>var counts = Sequence {};
var i = 0;
var n = count(0);
while (n &gt; 0) {
  counts.add(Sequence {&quot;&gt; &quot; + i, n});
  i = i + 1;
  n = count(i);
}

return counts;

operation count(n) {
  return Class.all.select(c|c.ownedOperationCount &gt; n).size;
}
</code></pre></div>

<p>This query produces a sequence of <code>&gt;x, y</code> pairs which indicate that <code>y</code> classes have more than <code>x</code> operations of their own.</p>
<p>Result:</p>
<div class="codehilite"><pre><span></span><code>[[&gt; 0, 4], [&gt; 1, 1], [&gt; 2, 1]]
</code></pre></div>





                
              </article>
            </div>
          
          
        </div>
        
      </main>
      
        
<footer class="md-footer">
  
    <div class="md-footer-nav">
      <nav class="md-footer-nav__inner md-grid">
        
          <a href="../core-concepts/" title="Core concepts" class="md-flex md-footer-nav__link md-footer-nav__link--prev" rel="prev">
            <div class="md-flex__cell md-flex__cell--shrink">
              <i class="md-icon md-icon--arrow-back md-footer-nav__button"></i>
            </div>
            <div class="md-flex__cell md-flex__cell--stretch md-footer-nav__title">
              <span class="md-flex__ellipsis">
                <span class="md-footer-nav__direction">
                  Previous
                </span>
                Core concepts
              </span>
            </div>
          </a>
        
        
          <a href="../examples-modelio/" title="Examples (Modelio)" class="md-flex md-footer-nav__link md-footer-nav__link--next" rel="next">
            <div class="md-flex__cell md-flex__cell--stretch md-footer-nav__title">
              <span class="md-flex__ellipsis">
                <span class="md-footer-nav__direction">
                  Next
                </span>
                Examples (Modelio)
              </span>
            </div>
            <div class="md-flex__cell md-flex__cell--shrink">
              <i class="md-icon md-icon--arrow-forward md-footer-nav__button"></i>
            </div>
          </a>
        
      </nav>
    </div>
  
  <div class="md-footer-meta md-typeset">
    <div class="md-footer-meta__inner md-grid">
      <div class="md-footer-copyright">
        
          <div class="md-footer-copyright__highlight">
            Copyright © Eclipse Foundation, Inc. All Rights Reserved.
          </div>
        
        powered by
        <a href="https://www.mkdocs.org">MkDocs</a>
        and
        <a href="https://squidfunk.github.io/mkdocs-material/">Material for MkDocs</a>
      </div>
      <div class="md-footer-copyright hawk-eclipse-links">
          <ul>
              <li><a href="https://www.eclipse.org/legal/privacy.php">Privacy Policy</a></li>
              <li><a href="https://www.eclipse.org/legal/termsofuse.php">Terms of Use</a></li>
              <li><a href="https://www.eclipse.org/legal/copyright.php">Copyright Agent</a></li>
          </ul>
      </div>
      <div class="md-social">
  
</div>
    </div>
  </div>
</footer>
      
    </div>
    <div class="md-dialog" data-md-component="dialog">
      <div class="md-dialog__inner md-typeset"></div>
    </div>
    
    <script id="__config" type="application/json">{"base": "../..", "features": [], "search": "../../assets/javascripts/workers/search.5bf1dace.min.js", "translations": {"clipboard.copied": "Copied to clipboard", "clipboard.copy": "Copy to clipboard", "search.config.lang": "en", "search.config.pipeline": "trimmer, stopWordFilter", "search.config.separator": "[\\s\\-]+", "search.placeholder": "Search", "search.result.more.one": "1 more on this page", "search.result.more.other": "# more on this page", "search.result.none": "No matching documents", "search.result.one": "1 matching document", "search.result.other": "# matching documents", "search.result.placeholder": "Type to start searching", "search.result.term.missing": "Missing", "select.version.title": "Select version"}}</script>
    
    
      <script src="../../assets/javascripts/bundle.078830c0.min.js"></script>
      
    
  </body>
</html>